#pragma once

#include <stdio.h>
#include "Items.h"
#include <process.h>
#include <windows.h>
#include <iostream>
#include <queue>

class CInstance
{
private:
	CItems items;
	int id;
	int n;
	int M;
	bool *best;
	int theBest;
	float GetMyCPUTime();
	void Clear(bool *sol, int n);
	void RecBB(int pos, int Mleft, int Cin, int Cleft, bool *actual);
	void Heur2();
	void Dyn();
	int map(const int &col, const int &row);
public:
	CInstance(FILE *file);
	int GetID();
	int GetNoElements();
	int GetCapacity();
	bool* GetCombSolution();
	int GetBestCost();
	float SolveBB(); // Branch and boundaries
	float SolveHeur2(); // by cost/weight ratio and then check the best item
	float SolveDyn(); // Dynamic programming;
	~CInstance(void);
	friend ostream& operator<<(ostream& x, const CInstance &a);
};

ostream& operator<<(ostream& x, const CInstance &a);