#include "Item.h"

CItem::CItem(void)
{
	this->cost = 0;
	this->weight = 0;
	this->ratio = 0;
	this->pos = 0;
}

CItem::CItem(const int &cost, const int &weight, const int &pos)
{
	this->cost = cost;
	this->weight = weight;
	this->ratio = (double)this->cost / (double)this->weight;
	this->pos = pos;
}

CItem::CItem(const CItem &a)
{
	this->cost = a.cost;
	this->weight = a.weight;
	this->ratio = a.ratio;
	this->pos = a.pos;
}

CItem::~CItem(void)
{
}

int CItem::GetCost()
{
	return this->cost;
}

int CItem::GetWeight()
{
	return this->weight;
}

double CItem::GetRatio()
{
	return this->ratio;
}

int CItem::GetPos()
{
	return this->pos;
}

CItem& CItem::operator=(const CItem& a)
{
	this->cost = a.cost;
	this->weight = a.weight;
	this->ratio = a.ratio;
	this->pos = a.pos;
	return *this;
}

bool operator<(const CItem &a, const CItem &b)
{
	if(a.ratio < b.ratio)
		return true;
	return false;
}