#include "Items.h"

CItems::CItems(void)
{
}

void CItems::LoadItems(FILE *file, const int &n)
{
	int weight;
	int cost;
	while(items.begin() != items.end()){
		delete (*items.begin());
		items.erase(items.begin());
	}
	totalCost = 0;
	for(int i=0; i<n; i++){
		fscanf_s(file, "%d %d", &weight, &cost);
		totalCost += cost;
		items.push_back(new CItem(cost, weight, i));
	}
}

int CItems::GetTotalCost()
{
	return this->totalCost;
}

int CItems::GetNoItems()
{
	return (int)this->items.size();
}

CItem& CItems::GetItem(const int &index)
{
	if( (index < 0) || (index >= (int)items.size() ))
		throw Exception("Item index out of bounds");
	return (*items.at(index));
}

CItems::~CItems(void)
{
	while(items.begin() != items.end()){
		delete (*items.begin());
		items.erase(items.begin());
	}
}
