// PAA_3.cpp : Defines the entry point for the console application.
//

#include "Instance.h"
#include <iostream>
#include <fstream>
#include "Exception.h"


#define DIF_SIZES 11
int sizes[DIF_SIZES] = {4, 10, 15, 20, 22, 25, 27, 30, 32, 35, 40};


int __cdecl main(int argc, char* argv[])
{
	int i, k;
	FILE *streamIn;
	ofstream streamOut;
	char filename[200];
	CInstance *inst;

	try{
	// Branch and bounds
		for(i=0; i<DIF_SIZES; i++)
		{
			sprintf_s(filename, 200, "./instances/knap_%d.txt", sizes[i]);
			fopen_s(&streamIn, filename, "r");
			sprintf_s(filename, 200, "./instances/knap_%d_BB.out", sizes[i]);
			streamOut.open(filename, ios::out);

			printf("Sizes: %d\n", sizes[i]);

			for(k=0; k<50; k++)
			{
				
				inst = new CInstance(streamIn);
				printf("Size: %d; ID: %d\n", inst->GetNoElements(), inst->GetID());
				float time = inst->SolveBB();
				streamOut << *inst;
				streamOut << "\t" << time << endl;
				streamOut.flush();

			}
			fclose(streamIn);
			streamOut.close();
		}
	// Heuristic 2
		for(i=0; i<DIF_SIZES; i++)
		{
			sprintf_s(filename, 200, "./instances/knap_%d.txt", sizes[i]);
			fopen_s(&streamIn, filename, "r");
			sprintf_s(filename, 200, "./instances/knap_%d_H2.out", sizes[i]);
			streamOut.open(filename, ios::out);

			printf("Sizes: %d\n", sizes[i]);

			for(k=0; k<50; k++)
			{
				
				inst = new CInstance(streamIn);
				printf("Size: %d; ID: %d\n", inst->GetNoElements(), inst->GetID());
				float time = inst->SolveHeur2();
				streamOut << *inst;
				streamOut << "\t" << time << endl;
				streamOut.flush();

			}
			fclose(streamIn);
			streamOut.close();
		}
	// Dynamic programming
		for(i=0; i<DIF_SIZES; i++)
		{
			sprintf_s(filename, 200, "./instances/knap_%d.txt", sizes[i]);
			fopen_s(&streamIn, filename, "r");
			sprintf_s(filename, 200, "./instances/knap_%d_Dyn.out", sizes[i]);
			streamOut.open(filename, ios::out);

			printf("Sizes: %d\n", sizes[i]);

			for(k=0; k<50; k++)
			{
				
				inst = new CInstance(streamIn);
				printf("Size: %d; ID: %d\n", inst->GetNoElements(), inst->GetID());
				float time = inst->SolveDyn();
				streamOut << *inst;
				streamOut << "\t" << time << endl;
				streamOut.flush();

			}
			fclose(streamIn);
			streamOut.close();
		}
	}catch(Exception e){
		cout << "Exception occured: " << e.m_Str << endl;
	}

	return 0;

}

